Index: XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 663)
+++ XIOS/trunk/src/interface/fortran_attr/idomain_attr.F90	(revision 664)
@@ -12,8 +12,8 @@
 
   SUBROUTINE xios(set_domain_attr)  &
-    ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
@@ -21,6 +21,8 @@
       CHARACTER(LEN=*), INTENT(IN) ::domain_id
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d(:,:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim
       INTEGER  , OPTIONAL, INTENT(IN) :: data_i_index(:)
@@ -37,9 +39,13 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_2d(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue(:)
-      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_2d(:,:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_1d(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d_tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_2d(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d_tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: name
       INTEGER  , OPTIONAL, INTENT(IN) :: ni
@@ -53,22 +59,24 @@
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
       CALL xios(set_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-      , standard_name, type )
+      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+      , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr)
 
   SUBROUTINE xios(set_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d(:,:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim
       INTEGER  , OPTIONAL, INTENT(IN) :: data_i_index(:)
@@ -85,9 +93,13 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_2d(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue(:)
-      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_2d(:,:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_1d(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d_tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_2d(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d_tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: name
       INTEGER  , OPTIONAL, INTENT(IN) :: ni
@@ -100,22 +112,25 @@
 
       CALL xios(set_domain_attr_hdl_)  &
-      ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-      , standard_name, type )
+      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+      , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
   END SUBROUTINE xios(set_domain_attr_hdl)
 
   SUBROUTINE xios(set_domain_attr_hdl_)   &
-    ( domain_hdl, area_, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
-    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, domain_ref_, i_index_  &
-    , ibegin_, j_index_, jbegin_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_  &
-    , nj_glo_, nvertex_, standard_name_, type_ )
+    ( domain_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_, data_ni_, data_nj_  &
+    , domain_group_ref_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
+    , nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(IN) :: area_(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_1d_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lat_2d_(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_1d_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: bounds_lon_2d_(:,:,:)
       INTEGER  , OPTIONAL, INTENT(IN) :: data_dim_
       INTEGER  , OPTIONAL, INTENT(IN) :: data_i_index_(:)
@@ -132,9 +147,13 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: j_index_(:)
       INTEGER  , OPTIONAL, INTENT(IN) :: jbegin_
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: latvalue_2d_(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: long_name_
-      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_(:)
-      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(IN) :: lonvalue_2d_(:,:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_1d_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d__tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_2d_(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d__tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: name_
       INTEGER  , OPTIONAL, INTENT(IN) :: ni_
@@ -150,10 +169,18 @@
       ENDIF
 
-      IF (PRESENT(bounds_lat_)) THEN
-        CALL cxios_set_domain_bounds_lat(domain_hdl%daddr, bounds_lat_, size(bounds_lat_,1), size(bounds_lat_,2))
-      ENDIF
-
-      IF (PRESENT(bounds_lon_)) THEN
-        CALL cxios_set_domain_bounds_lon(domain_hdl%daddr, bounds_lon_, size(bounds_lon_,1), size(bounds_lon_,2))
+      IF (PRESENT(bounds_lat_1d_)) THEN
+        CALL cxios_set_domain_bounds_lat_1d(domain_hdl%daddr, bounds_lat_1d_, size(bounds_lat_1d_,1), size(bounds_lat_1d_,2))
+      ENDIF
+
+      IF (PRESENT(bounds_lat_2d_)) THEN
+        CALL cxios_set_domain_bounds_lat_2d(domain_hdl%daddr, bounds_lat_2d_, size(bounds_lat_2d_,1), size(bounds_lat_2d_,2), size(bounds_lat_2d_,3))
+      ENDIF
+
+      IF (PRESENT(bounds_lon_1d_)) THEN
+        CALL cxios_set_domain_bounds_lon_1d(domain_hdl%daddr, bounds_lon_1d_, size(bounds_lon_1d_,1), size(bounds_lon_1d_,2))
+      ENDIF
+
+      IF (PRESENT(bounds_lon_2d_)) THEN
+        CALL cxios_set_domain_bounds_lon_2d(domain_hdl%daddr, bounds_lon_2d_, size(bounds_lon_2d_,1), size(bounds_lon_2d_,2), size(bounds_lon_2d_,3))
       ENDIF
 
@@ -214,6 +241,10 @@
       ENDIF
 
-      IF (PRESENT(latvalue_)) THEN
-        CALL cxios_set_domain_latvalue(domain_hdl%daddr, latvalue_, size(latvalue_,1))
+      IF (PRESENT(latvalue_1d_)) THEN
+        CALL cxios_set_domain_latvalue_1d(domain_hdl%daddr, latvalue_1d_, size(latvalue_1d_,1))
+      ENDIF
+
+      IF (PRESENT(latvalue_2d_)) THEN
+        CALL cxios_set_domain_latvalue_2d(domain_hdl%daddr, latvalue_2d_, size(latvalue_2d_,1), size(latvalue_2d_,2))
       ENDIF
 
@@ -222,12 +253,22 @@
       ENDIF
 
-      IF (PRESENT(lonvalue_)) THEN
-        CALL cxios_set_domain_lonvalue(domain_hdl%daddr, lonvalue_, size(lonvalue_,1))
-      ENDIF
-
-      IF (PRESENT(mask_)) THEN
-        ALLOCATE(mask__tmp(size(mask_,1), size(mask_,2)))
-        mask__tmp = mask_
-        CALL cxios_set_domain_mask(domain_hdl%daddr, mask__tmp, size(mask_,1), size(mask_,2))
+      IF (PRESENT(lonvalue_1d_)) THEN
+        CALL cxios_set_domain_lonvalue_1d(domain_hdl%daddr, lonvalue_1d_, size(lonvalue_1d_,1))
+      ENDIF
+
+      IF (PRESENT(lonvalue_2d_)) THEN
+        CALL cxios_set_domain_lonvalue_2d(domain_hdl%daddr, lonvalue_2d_, size(lonvalue_2d_,1), size(lonvalue_2d_,2))
+      ENDIF
+
+      IF (PRESENT(mask_1d_)) THEN
+        ALLOCATE(mask_1d__tmp(size(mask_1d_,1)))
+        mask_1d__tmp = mask_1d_
+        CALL cxios_set_domain_mask_1d(domain_hdl%daddr, mask_1d__tmp, size(mask_1d_,1))
+      ENDIF
+
+      IF (PRESENT(mask_2d_)) THEN
+        ALLOCATE(mask_2d__tmp(size(mask_2d_,1), size(mask_2d_,2)))
+        mask_2d__tmp = mask_2d_
+        CALL cxios_set_domain_mask_2d(domain_hdl%daddr, mask_2d__tmp, size(mask_2d_,1), size(mask_2d_,2))
       ENDIF
 
@@ -267,8 +308,8 @@
 
   SUBROUTINE xios(get_domain_attr)  &
-    ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
@@ -276,6 +317,8 @@
       CHARACTER(LEN=*), INTENT(IN) ::domain_id
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d(:,:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_i_index(:)
@@ -292,9 +335,13 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_2d(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue(:)
-      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_2d(:,:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_1d(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d_tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_2d(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d_tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: name
       INTEGER  , OPTIONAL, INTENT(OUT) :: ni
@@ -308,22 +355,24 @@
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
       CALL xios(get_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-      , standard_name, type )
+      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+      , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr)
 
   SUBROUTINE xios(get_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_1d(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d(:,:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_i_index(:)
@@ -340,9 +389,13 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: j_index(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_2d(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue(:)
-      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_1d(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_2d(:,:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_1d(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d_tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_2d(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d_tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: name
       INTEGER  , OPTIONAL, INTENT(OUT) :: ni
@@ -355,22 +408,25 @@
 
       CALL xios(get_domain_attr_hdl_)  &
-      ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-      , standard_name, type )
+      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+      , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
   END SUBROUTINE xios(get_domain_attr_hdl)
 
   SUBROUTINE xios(get_domain_attr_hdl_)   &
-    ( domain_hdl, area_, bounds_lat_, bounds_lon_, data_dim_, data_i_index_, data_ibegin_, data_j_index_  &
-    , data_jbegin_, data_n_index_, data_ni_, data_nj_, domain_group_ref_, domain_ref_, i_index_  &
-    , ibegin_, j_index_, jbegin_, latvalue_, long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_  &
-    , nj_glo_, nvertex_, standard_name_, type_ )
+    ( domain_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_, data_ni_, data_nj_  &
+    , domain_group_ref_, domain_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
+    , nvertex_, standard_name_, type_ )
 
     IMPLICIT NONE
       TYPE(txios(domain)) , INTENT(IN) :: domain_hdl
       REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: area_(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_(:,:)
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_1d_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lat_2d_(:,:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_1d_(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: bounds_lon_2d_(:,:,:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_dim_
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_i_index_(:)
@@ -387,9 +443,13 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: j_index_(:)
       INTEGER  , OPTIONAL, INTENT(OUT) :: jbegin_
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: latvalue_2d_(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: long_name_
-      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_(:)
-      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_(:,:)
-      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:,:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_1d_(:)
+      REAL (KIND=8) , OPTIONAL, INTENT(OUT) :: lonvalue_2d_(:,:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_1d_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_1d__tmp(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_2d_(:,:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_2d__tmp(:,:)
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: name_
       INTEGER  , OPTIONAL, INTENT(OUT) :: ni_
@@ -405,10 +465,18 @@
       ENDIF
 
-      IF (PRESENT(bounds_lat_)) THEN
-        CALL cxios_get_domain_bounds_lat(domain_hdl%daddr, bounds_lat_, size(bounds_lat_,1), size(bounds_lat_,2))
-      ENDIF
-
-      IF (PRESENT(bounds_lon_)) THEN
-        CALL cxios_get_domain_bounds_lon(domain_hdl%daddr, bounds_lon_, size(bounds_lon_,1), size(bounds_lon_,2))
+      IF (PRESENT(bounds_lat_1d_)) THEN
+        CALL cxios_get_domain_bounds_lat_1d(domain_hdl%daddr, bounds_lat_1d_, size(bounds_lat_1d_,1), size(bounds_lat_1d_,2))
+      ENDIF
+
+      IF (PRESENT(bounds_lat_2d_)) THEN
+        CALL cxios_get_domain_bounds_lat_2d(domain_hdl%daddr, bounds_lat_2d_, size(bounds_lat_2d_,1), size(bounds_lat_2d_,2), size(bounds_lat_2d_,3))
+      ENDIF
+
+      IF (PRESENT(bounds_lon_1d_)) THEN
+        CALL cxios_get_domain_bounds_lon_1d(domain_hdl%daddr, bounds_lon_1d_, size(bounds_lon_1d_,1), size(bounds_lon_1d_,2))
+      ENDIF
+
+      IF (PRESENT(bounds_lon_2d_)) THEN
+        CALL cxios_get_domain_bounds_lon_2d(domain_hdl%daddr, bounds_lon_2d_, size(bounds_lon_2d_,1), size(bounds_lon_2d_,2), size(bounds_lon_2d_,3))
       ENDIF
 
@@ -469,6 +537,10 @@
       ENDIF
 
-      IF (PRESENT(latvalue_)) THEN
-        CALL cxios_get_domain_latvalue(domain_hdl%daddr, latvalue_, size(latvalue_,1))
+      IF (PRESENT(latvalue_1d_)) THEN
+        CALL cxios_get_domain_latvalue_1d(domain_hdl%daddr, latvalue_1d_, size(latvalue_1d_,1))
+      ENDIF
+
+      IF (PRESENT(latvalue_2d_)) THEN
+        CALL cxios_get_domain_latvalue_2d(domain_hdl%daddr, latvalue_2d_, size(latvalue_2d_,1), size(latvalue_2d_,2))
       ENDIF
 
@@ -477,12 +549,22 @@
       ENDIF
 
-      IF (PRESENT(lonvalue_)) THEN
-        CALL cxios_get_domain_lonvalue(domain_hdl%daddr, lonvalue_, size(lonvalue_,1))
-      ENDIF
-
-      IF (PRESENT(mask_)) THEN
-        ALLOCATE(mask__tmp(size(mask_,1), size(mask_,2)))
-        CALL cxios_get_domain_mask(domain_hdl%daddr, mask__tmp, size(mask_,1), size(mask_,2))
-        mask_ = mask__tmp
+      IF (PRESENT(lonvalue_1d_)) THEN
+        CALL cxios_get_domain_lonvalue_1d(domain_hdl%daddr, lonvalue_1d_, size(lonvalue_1d_,1))
+      ENDIF
+
+      IF (PRESENT(lonvalue_2d_)) THEN
+        CALL cxios_get_domain_lonvalue_2d(domain_hdl%daddr, lonvalue_2d_, size(lonvalue_2d_,1), size(lonvalue_2d_,2))
+      ENDIF
+
+      IF (PRESENT(mask_1d_)) THEN
+        ALLOCATE(mask_1d__tmp(size(mask_1d_,1)))
+        CALL cxios_get_domain_mask_1d(domain_hdl%daddr, mask_1d__tmp, size(mask_1d_,1))
+        mask_1d_ = mask_1d__tmp
+      ENDIF
+
+      IF (PRESENT(mask_2d_)) THEN
+        ALLOCATE(mask_2d__tmp(size(mask_2d_,1), size(mask_2d_,2)))
+        CALL cxios_get_domain_mask_2d(domain_hdl%daddr, mask_2d__tmp, size(mask_2d_,1), size(mask_2d_,2))
+        mask_2d_ = mask_2d__tmp
       ENDIF
 
@@ -522,8 +604,8 @@
 
   SUBROUTINE xios(is_defined_domain_attr)  &
-    ( domain_id, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
@@ -532,8 +614,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: area
       LOGICAL(KIND=C_BOOL) :: area_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat
-      LOGICAL(KIND=C_BOOL) :: bounds_lat_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon
-      LOGICAL(KIND=C_BOOL) :: bounds_lon_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_1d
+      LOGICAL(KIND=C_BOOL) :: bounds_lat_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_2d
+      LOGICAL(KIND=C_BOOL) :: bounds_lat_2d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_1d
+      LOGICAL(KIND=C_BOOL) :: bounds_lon_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_2d
+      LOGICAL(KIND=C_BOOL) :: bounds_lon_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_dim
       LOGICAL(KIND=C_BOOL) :: data_dim_tmp
@@ -564,12 +650,18 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
-      LOGICAL(KIND=C_BOOL) :: latvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_1d
+      LOGICAL(KIND=C_BOOL) :: latvalue_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_2d
+      LOGICAL(KIND=C_BOOL) :: latvalue_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: long_name
       LOGICAL(KIND=C_BOOL) :: long_name_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue
-      LOGICAL(KIND=C_BOOL) :: lonvalue_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
-      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue_1d
+      LOGICAL(KIND=C_BOOL) :: lonvalue_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue_2d
+      LOGICAL(KIND=C_BOOL) :: lonvalue_2d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_1d
+      LOGICAL(KIND=C_BOOL) :: mask_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_2d
+      LOGICAL(KIND=C_BOOL) :: mask_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: name
       LOGICAL(KIND=C_BOOL) :: name_tmp
@@ -591,16 +683,16 @@
       CALL xios(get_domain_handle)(domain_id,domain_hdl)
       CALL xios(is_defined_domain_attr_hdl_)   &
-      ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-      , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-      , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-      , standard_name, type )
+      ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+      , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+      , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+      , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
   END SUBROUTINE xios(is_defined_domain_attr)
 
   SUBROUTINE xios(is_defined_domain_attr_hdl)  &
-    ( domain_hdl, area, bounds_lat, bounds_lon, data_dim, data_i_index, data_ibegin, data_j_index  &
-    , data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref, i_index, ibegin  &
-    , j_index, jbegin, latvalue, long_name, lonvalue, mask, name, ni, ni_glo, nj, nj_glo, nvertex  &
-    , standard_name, type )
+    ( domain_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim, data_i_index  &
+    , data_ibegin, data_j_index, data_jbegin, data_n_index, data_ni, data_nj, domain_group_ref, domain_ref  &
+    , i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d, lonvalue_2d  &
+    , mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type )
 
     IMPLICIT NONE
@@ -608,8 +700,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: area
       LOGICAL(KIND=C_BOOL) :: area_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat
-      LOGICAL(KIND=C_BOOL) :: bounds_lat_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon
-      LOGICAL(KIND=C_BOOL) :: bounds_lon_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_1d
+      LOGICAL(KIND=C_BOOL) :: bounds_lat_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lat_2d
+      LOGICAL(KIND=C_BOOL) :: bounds_lat_2d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_1d
+      LOGICAL(KIND=C_BOOL) :: bounds_lon_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: bounds_lon_2d
+      LOGICAL(KIND=C_BOOL) :: bounds_lon_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_dim
       LOGICAL(KIND=C_BOOL) :: data_dim_tmp
@@ -640,12 +736,18 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
       LOGICAL(KIND=C_BOOL) :: jbegin_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
-      LOGICAL(KIND=C_BOOL) :: latvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_1d
+      LOGICAL(KIND=C_BOOL) :: latvalue_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_2d
+      LOGICAL(KIND=C_BOOL) :: latvalue_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: long_name
       LOGICAL(KIND=C_BOOL) :: long_name_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue
-      LOGICAL(KIND=C_BOOL) :: lonvalue_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
-      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue_1d
+      LOGICAL(KIND=C_BOOL) :: lonvalue_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue_2d
+      LOGICAL(KIND=C_BOOL) :: lonvalue_2d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_1d
+      LOGICAL(KIND=C_BOOL) :: mask_1d_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_2d
+      LOGICAL(KIND=C_BOOL) :: mask_2d_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: name
       LOGICAL(KIND=C_BOOL) :: name_tmp
